diff -crN ../src.orig/backend/access/heap/heapam.c ./backend/access/heap/heapam.c
*** ../src.orig/backend/access/heap/heapam.c	Sat Jun  2 11:17:47 2001
--- ./backend/access/heap/heapam.c	Sat Jun  2 11:18:33 2001
***************
*** 87,92 ****
--- 87,93 ----
  #include "utils/relcache.h"
  
  #include "access/xlogutils.h"
+ #include "pgstat.h"
  
  XLogRecPtr log_heap_move(Relation reln, Buffer oldbuf, ItemPointerData from,
  			  Buffer newbuf, HeapTuple newtup);
***************
*** 595,600 ****
--- 596,603 ----
  	if (lockmode != NoLock)
  		LockRelation(r, lockmode);
  
+ 	pgstat_initstats(&r->pgstat_info, r);
+ 
  	return r;
  }
  
***************
*** 632,637 ****
--- 635,642 ----
  	if (lockmode != NoLock)
  		LockRelation(r, lockmode);
  
+ 	pgstat_initstats(&r->pgstat_info, r);
+ 
  	return r;
  }
  
***************
*** 662,667 ****
--- 667,675 ----
  	if (RelationIsValid(r) && r->rd_rel->relkind == RELKIND_INDEX)
  		elog(ERROR, "%s is an index relation", RelationGetRelationName(r));
  
+ 	if (RelationIsValid(r))
+ 		pgstat_initstats(&r->pgstat_info, r);
+ 
  	return r;
  }
  
***************
*** 692,697 ****
--- 700,708 ----
  	if (RelationIsValid(r) && r->rd_rel->relkind == RELKIND_INDEX)
  		elog(ERROR, "%s is an index relation", RelationGetRelationName(r));
  
+ 	if (RelationIsValid(r))
+ 		pgstat_initstats(&r->pgstat_info, r);
+ 
  	return r;
  }
  
***************
*** 770,775 ****
--- 781,788 ----
  	scan->rs_snapshot = snapshot;
  	scan->rs_nkeys = (short) nkeys;
  
+ 	pgstat_initstats(&scan->rs_pgstat_info, relation);
+ 
  	/*
  	 * we do this here instead of in initscan() because heap_rescan also
  	 * calls initscan() and we don't want to allocate memory again
***************
*** 793,799 ****
  			bool scanFromEnd,
  			ScanKey key)
  {
- 
  	/*
  	 * increment access statistics
  	 */
--- 806,811 ----
***************
*** 810,815 ****
--- 822,829 ----
  	 */
  	scan->rs_atend = scanFromEnd;
  	initscan(scan, scan->rs_rd, scanFromEnd, scan->rs_nkeys, key);
+ 
+ 	pgstat_reset_heap_scan(&scan->rs_pgstat_info);
  }
  
  /* ----------------
***************
*** 908,913 ****
--- 922,929 ----
  	if (scan == NULL)
  		elog(ERROR, "heap_getnext: NULL relscan");
  
+ 	pgstat_count_heap_scan(&scan->rs_pgstat_info);
+ 
  	/*
  	 * initialize return buffer to InvalidBuffer
  	 */
***************
*** 1076,1081 ****
--- 1092,1100 ----
  
  	HEAPDEBUG_7;				/* heap_getnext returning tuple */
  
+ 	if (scan->rs_ctup.t_data != NULL)
+ 		pgstat_count_heap_getnext(&scan->rs_pgstat_info);
+ 
  	return ((scan->rs_ctup.t_data == NULL) ? NULL : &(scan->rs_ctup));
  }
  
***************
*** 1096,1102 ****
  heap_fetch(Relation relation,
  		   Snapshot snapshot,
  		   HeapTuple tuple,
! 		   Buffer *userbuf)
  {
  	ItemId		lp;
  	Buffer		buffer;
--- 1115,1122 ----
  heap_fetch(Relation relation,
  		   Snapshot snapshot,
  		   HeapTuple tuple,
! 		   Buffer *userbuf,
! 		   IndexScanDesc iscan)
  {
  	ItemId		lp;
  	Buffer		buffer;
***************
*** 1171,1176 ****
--- 1191,1201 ----
  		 * responsible for releasing the buffer.
  		 */
  		*userbuf = buffer;
+ 
+ 		if (iscan != NULL)
+ 			pgstat_count_heap_fetch(&iscan->xs_pgstat_info);
+ 		else
+ 			pgstat_count_heap_fetch(&relation->pgstat_info);
  	}
  }
  
***************
*** 1322,1327 ****
--- 1347,1354 ----
  	START_CRIT_SECTION();
  	RelationPutHeapTuple(relation, buffer, tup);
  
+ 	pgstat_count_heap_insert(&relation->pgstat_info);
+ 
  	/* XLOG stuff */
  	{
  		xl_heap_insert xlrec;
***************
*** 1510,1515 ****
--- 1537,1544 ----
  		heap_tuple_toast_attrs(relation, NULL, &(tp));
  #endif
  
+ 	pgstat_count_heap_delete(&relation->pgstat_info);
+ 
  	/*
  	 * Mark tuple for invalidation from system caches at next command
  	 * boundary. We have to do this before WriteBuffer because we need to
***************
*** 1768,1773 ****
--- 1797,1804 ----
  		already_marked = false;
  		newbuf = buffer;
  	}
+ 
+ 	pgstat_count_heap_update(&relation->pgstat_info);
  
  	/*
  	 * At this point newbuf and buffer are both pinned and locked,
diff -crN ../src.orig/backend/access/heap/tuptoaster.c ./backend/access/heap/tuptoaster.c
*** ../src.orig/backend/access/heap/tuptoaster.c	Sat Jun  2 11:17:47 2001
--- ./backend/access/heap/tuptoaster.c	Sat Jun  2 11:18:33 2001
***************
*** 936,942 ****
  	while ((indexRes = index_getnext(toastscan, ForwardScanDirection)) != NULL)
  	{
  		toasttup.t_self = indexRes->heap_iptr;
! 		heap_fetch(toastrel, SnapshotAny, &toasttup, &buffer);
  		pfree(indexRes);
  
  		if (!toasttup.t_data)
--- 936,942 ----
  	while ((indexRes = index_getnext(toastscan, ForwardScanDirection)) != NULL)
  	{
  		toasttup.t_self = indexRes->heap_iptr;
! 		heap_fetch(toastrel, SnapshotAny, &toasttup, &buffer, toastscan);
  		pfree(indexRes);
  
  		if (!toasttup.t_data)
***************
*** 1029,1035 ****
  	while ((indexRes = index_getnext(toastscan, ForwardScanDirection)) != NULL)
  	{
  		toasttup.t_self = indexRes->heap_iptr;
! 		heap_fetch(toastrel, SnapshotAny, &toasttup, &buffer);
  		pfree(indexRes);
  
  		if (toasttup.t_data == NULL)
--- 1029,1035 ----
  	while ((indexRes = index_getnext(toastscan, ForwardScanDirection)) != NULL)
  	{
  		toasttup.t_self = indexRes->heap_iptr;
! 		heap_fetch(toastrel, SnapshotAny, &toasttup, &buffer, toastscan);
  		pfree(indexRes);
  
  		if (toasttup.t_data == NULL)
diff -crN ../src.orig/backend/access/index/genam.c ./backend/access/index/genam.c
*** ../src.orig/backend/access/index/genam.c	Sat Jun  2 11:17:47 2001
--- ./backend/access/index/genam.c	Sat Jun  2 11:18:33 2001
***************
*** 48,53 ****
--- 48,54 ----
  #include "postgres.h"
  #include "access/genam.h"
  
+ #include "pgstat.h"
  
  /* ----------------------------------------------------------------
   *		general access method routines
***************
*** 113,118 ****
--- 114,121 ----
  	ItemPointerSetInvalid(&scan->previousMarkData);
  	ItemPointerSetInvalid(&scan->currentMarkData);
  	ItemPointerSetInvalid(&scan->nextMarkData);
+ 
+ 	pgstat_initstats(&scan->xs_pgstat_info, relation);
  
  	/*
  	 * mark cached function lookup data invalid; it will be set on first
diff -crN ../src.orig/backend/access/index/indexam.c ./backend/access/index/indexam.c
*** ../src.orig/backend/access/index/indexam.c	Sat Jun  2 11:17:47 2001
--- ./backend/access/index/indexam.c	Sat Jun  2 11:19:15 2001
***************
*** 70,75 ****
--- 70,76 ----
  #include "access/heapam.h"
  #include "utils/relcache.h"
  
+ #include "pgstat.h"
  
  /* ----------------------------------------------------------------
   *					macros used in index_ routines
***************
*** 135,140 ****
--- 136,143 ----
  	if (r->rd_rel->relkind != RELKIND_INDEX)
  		elog(ERROR, "%s is not an index relation", RelationGetRelationName(r));
  
+ 	pgstat_initstats(&r->pgstat_info, r);
+ 
  	return r;
  }
  
***************
*** 157,162 ****
--- 160,167 ----
  	if (r->rd_rel->relkind != RELKIND_INDEX)
  		elog(ERROR, "%s is not an index relation", RelationGetRelationName(r));
  
+ 	pgstat_initstats(&r->pgstat_info, r);
+ 
  	return r;
  }
  
***************
*** 256,261 ****
--- 261,268 ----
  										 UInt16GetDatum(numberOfKeys),
  										 PointerGetDatum(key)));
  
+ 	pgstat_initstats(&scan->xs_pgstat_info, relation);
+ 
  	/*
  	 * We want to look up the amgettuple procedure just once per scan,
  	 * not once per index_getnext call.  So do it here and save
***************
*** 283,288 ****
--- 290,297 ----
  					 PointerGetDatum(scan),
  					 BoolGetDatum(scanFromEnd),
  					 PointerGetDatum(key));
+ 
+ 	pgstat_reset_index_scan(&scan->xs_pgstat_info);
  }
  
  /* ----------------
***************
*** 353,358 ****
--- 362,369 ----
  
  	SCAN_CHECKS;
  
+ 	pgstat_count_index_scan(&scan->xs_pgstat_info);
+ 
  	/*
  	 * have the am's gettuple proc do all the work.
  	 * index_beginscan already set up fn_getnext.
***************
*** 362,367 ****
--- 373,380 ----
  									  PointerGetDatum(scan),
  									  Int32GetDatum(direction)));
  
+ 	if (result != NULL)
+ 		pgstat_count_index_getnext(&scan->xs_pgstat_info);
  	return result;
  }
  
diff -crN ../src.orig/backend/access/nbtree/nbtinsert.c ./backend/access/nbtree/nbtinsert.c
*** ../src.orig/backend/access/nbtree/nbtinsert.c	Sat Jun  2 11:17:47 2001
--- ./backend/access/nbtree/nbtinsert.c	Sat Jun  2 11:18:33 2001
***************
*** 209,215 ****
  			if (chtup)
  			{
  				htup.t_self = btitem->bti_itup.t_tid;
! 				heap_fetch(heapRel, SnapshotDirty, &htup, &buffer);
  				if (htup.t_data == NULL)		/* YES! */
  					break;
  				/* Live tuple is being inserted, so continue checking */
--- 209,215 ----
  			if (chtup)
  			{
  				htup.t_self = btitem->bti_itup.t_tid;
! 				heap_fetch(heapRel, SnapshotDirty, &htup, &buffer, NULL);
  				if (htup.t_data == NULL)		/* YES! */
  					break;
  				/* Live tuple is being inserted, so continue checking */
***************
*** 219,225 ****
  
  			cbti = (BTItem) PageGetItem(page, PageGetItemId(page, offset));
  			htup.t_self = cbti->bti_itup.t_tid;
! 			heap_fetch(heapRel, SnapshotDirty, &htup, &buffer);
  			if (htup.t_data != NULL)	/* it is a duplicate */
  			{
  				TransactionId xwait =
--- 219,225 ----
  
  			cbti = (BTItem) PageGetItem(page, PageGetItemId(page, offset));
  			htup.t_self = cbti->bti_itup.t_tid;
! 			heap_fetch(heapRel, SnapshotDirty, &htup, &buffer, NULL);
  			if (htup.t_data != NULL)	/* it is a duplicate */
  			{
  				TransactionId xwait =
diff -crN ../src.orig/backend/access/transam/xact.c ./backend/access/transam/xact.c
*** ../src.orig/backend/access/transam/xact.c	Sat Jun  2 11:17:48 2001
--- ./backend/access/transam/xact.c	Sat Jun  2 11:18:33 2001
***************
*** 176,181 ****
--- 176,183 ----
  #include "utils/relcache.h"
  #include "utils/temprel.h"
  
+ #include "pgstat.h"
+ 
  extern bool SharedBufferChanged;
  
  static void AbortTransaction(void);
***************
*** 1088,1093 ****
--- 1090,1098 ----
  
  	SharedBufferChanged = false;/* safest place to do it */
  
+ 	/* Count transaction commit in statistics collector */
+ 	pgstat_count_xact_commit();
+ 
  	/*
  	 * done with commit processing, set current transaction state back to
  	 * default
***************
*** 1167,1172 ****
--- 1172,1180 ----
  	CloseSequences();
  	AtEOXact_portals();
  	RecordTransactionAbort();
+ 
+ 	/* Count transaction abort in statistics collector */
+ 	pgstat_count_xact_rollback();
  
  	RelationPurgeLocalRelation(false);
  	AtEOXact_temp_relations(false);
diff -crN ../src.orig/backend/catalog/indexing.c ./backend/catalog/indexing.c
*** ../src.orig/backend/catalog/indexing.c	Sat Jun  2 11:17:48 2001
--- ./backend/catalog/indexing.c	Sat Jun  2 11:18:33 2001
***************
*** 204,210 ****
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(heapRelation, SnapshotNow, &tuple, &buffer);
  		pfree(indexRes);
  		if (tuple.t_data != NULL)
  			break;
--- 204,210 ----
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(heapRelation, SnapshotNow, &tuple, &buffer, sd);
  		pfree(indexRes);
  		if (tuple.t_data != NULL)
  			break;
diff -crN ../src.orig/backend/catalog/pg_largeobject.c ./backend/catalog/pg_largeobject.c
*** ../src.orig/backend/catalog/pg_largeobject.c	Sat Jun  2 11:17:48 2001
--- ./backend/catalog/pg_largeobject.c	Sat Jun  2 11:18:33 2001
***************
*** 114,120 ****
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(pg_largeobject, SnapshotNow, &tuple, &buffer);
  		pfree(indexRes);
  		if (tuple.t_data != NULL)
  		{
--- 114,120 ----
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(pg_largeobject, SnapshotNow, &tuple, &buffer, sd);
  		pfree(indexRes);
  		if (tuple.t_data != NULL)
  		{
***************
*** 165,171 ****
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(pg_largeobject, SnapshotNow, &tuple, &buffer);
  		pfree(indexRes);
  		if (tuple.t_data != NULL)
  		{
--- 165,171 ----
  	while ((indexRes = index_getnext(sd, ForwardScanDirection)))
  	{
  		tuple.t_self = indexRes->heap_iptr;
! 		heap_fetch(pg_largeobject, SnapshotNow, &tuple, &buffer, sd);
  		pfree(indexRes);
  		if (tuple.t_data != NULL)
  		{
diff -crN ../src.orig/backend/commands/analyze.c ./backend/commands/analyze.c
*** ../src.orig/backend/commands/analyze.c	Sat Jun  2 11:17:48 2001
--- ./backend/commands/analyze.c	Sat Jun  2 11:18:33 2001
***************
*** 607,613 ****
  				goto pageloop;
  			}
  			ItemPointerSet(&targtuple.t_self, targblock, targoffset);
! 			heap_fetch(onerel, SnapshotNow, &targtuple, &targbuffer);
  			if (targtuple.t_data != NULL)
  			{
  				/*
--- 607,613 ----
  				goto pageloop;
  			}
  			ItemPointerSet(&targtuple.t_self, targblock, targoffset);
! 			heap_fetch(onerel, SnapshotNow, &targtuple, &targbuffer, NULL);
  			if (targtuple.t_data != NULL)
  			{
  				/*
diff -crN ../src.orig/backend/commands/cluster.c ./backend/commands/cluster.c
*** ../src.orig/backend/commands/cluster.c	Sat Jun  2 11:17:48 2001
--- ./backend/commands/cluster.c	Sat Jun  2 11:18:33 2001
***************
*** 264,270 ****
  		LocalHeapTuple.t_self = ScanResult->heap_iptr;
  		LocalHeapTuple.t_datamcxt = NULL;
  		LocalHeapTuple.t_data = NULL;
! 		heap_fetch(LocalOldHeap, SnapshotNow, &LocalHeapTuple, &LocalBuffer);
  		if (LocalHeapTuple.t_data != NULL)
  		{
  
--- 264,271 ----
  		LocalHeapTuple.t_self = ScanResult->heap_iptr;
  		LocalHeapTuple.t_datamcxt = NULL;
  		LocalHeapTuple.t_data = NULL;
! 		heap_fetch(LocalOldHeap, SnapshotNow, &LocalHeapTuple, &LocalBuffer,
! 						ScanDesc);
  		if (LocalHeapTuple.t_data != NULL)
  		{
  
diff -crN ../src.orig/backend/commands/trigger.c ./backend/commands/trigger.c
*** ../src.orig/backend/commands/trigger.c	Sat Jun  2 11:17:48 2001
--- ./backend/commands/trigger.c	Sat Jun  2 11:18:33 2001
***************
*** 551,557 ****
  				break;
  
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(tgrel, SnapshotNow, &tuple, &buffer);
  			pfree(indexRes);
  			if (!tuple.t_data)
  				continue;
--- 551,557 ----
  				break;
  
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(tgrel, SnapshotNow, &tuple, &buffer, sd);
  			pfree(indexRes);
  			if (!tuple.t_data)
  				continue;
***************
*** 1394,1400 ****
  	if (ItemPointerIsValid(&(event->dte_oldctid)))
  	{
  		ItemPointerCopy(&(event->dte_oldctid), &(oldtuple.t_self));
! 		heap_fetch(rel, SnapshotAny, &oldtuple, &oldbuffer);
  		if (!oldtuple.t_data)
  			elog(ERROR, "DeferredTriggerExecute: failed to fetch old tuple");
  	}
--- 1394,1400 ----
  	if (ItemPointerIsValid(&(event->dte_oldctid)))
  	{
  		ItemPointerCopy(&(event->dte_oldctid), &(oldtuple.t_self));
! 		heap_fetch(rel, SnapshotAny, &oldtuple, &oldbuffer, NULL);
  		if (!oldtuple.t_data)
  			elog(ERROR, "DeferredTriggerExecute: failed to fetch old tuple");
  	}
***************
*** 1402,1408 ****
  	if (ItemPointerIsValid(&(event->dte_newctid)))
  	{
  		ItemPointerCopy(&(event->dte_newctid), &(newtuple.t_self));
! 		heap_fetch(rel, SnapshotAny, &newtuple, &newbuffer);
  		if (!newtuple.t_data)
  			elog(ERROR, "DeferredTriggerExecute: failed to fetch new tuple");
  	}
--- 1402,1408 ----
  	if (ItemPointerIsValid(&(event->dte_newctid)))
  	{
  		ItemPointerCopy(&(event->dte_newctid), &(newtuple.t_self));
! 		heap_fetch(rel, SnapshotAny, &newtuple, &newbuffer, NULL);
  		if (!newtuple.t_data)
  			elog(ERROR, "DeferredTriggerExecute: failed to fetch new tuple");
  	}
***************
*** 1861,1867 ****
  					break;
  
  				tuple.t_self = indexRes->heap_iptr;
! 				heap_fetch(tgrel, SnapshotNow, &tuple, &buffer);
  				pfree(indexRes);
  				if (!tuple.t_data)
  					continue;
--- 1861,1867 ----
  					break;
  
  				tuple.t_self = indexRes->heap_iptr;
! 				heap_fetch(tgrel, SnapshotNow, &tuple, &buffer, sd);
  				pfree(indexRes);
  				if (!tuple.t_data)
  					continue;
diff -crN ../src.orig/backend/commands/vacuum.c ./backend/commands/vacuum.c
*** ../src.orig/backend/commands/vacuum.c	Sat Jun  2 11:17:48 2001
--- ./backend/commands/vacuum.c	Sat Jun  2 11:18:33 2001
***************
*** 48,53 ****
--- 48,55 ----
  #include "utils/syscache.h"
  #include "utils/temprel.h"
  
+ #include "pgstat.h"
+ 
  extern XLogRecPtr log_heap_clean(Relation reln, Buffer buffer,
  			   char *unused, int unlen);
  extern XLogRecPtr log_heap_move(Relation reln,
***************
*** 185,190 ****
--- 187,197 ----
  	if (IsTransactionBlock())
  		elog(ERROR, "%s cannot run inside a BEGIN/END block", stmttype);
  
+ 	/*
+ 	 * Send info about dead objects to the statistics collector
+ 	 */
+ 	pgstat_vacuum_tabstat();
+ 
  	if (vacstmt->verbose)
  		MESSAGE_LEVEL = NOTICE;
  	else
***************
*** 2345,2351 ****
  	/* get the buffer cache tuple */
  	rtup.t_self = ctup->t_self;
  	ReleaseSysCache(ctup);
! 	heap_fetch(rd, SnapshotNow, &rtup, &buffer);
  
  	/* overwrite the existing statistics in the tuple */
  	pgcform = (Form_pg_class) GETSTRUCT(&rtup);
--- 2352,2358 ----
  	/* get the buffer cache tuple */
  	rtup.t_self = ctup->t_self;
  	ReleaseSysCache(ctup);
! 	heap_fetch(rd, SnapshotNow, &rtup, &buffer, NULL);
  
  	/* overwrite the existing statistics in the tuple */
  	pgcform = (Form_pg_class) GETSTRUCT(&rtup);
diff -crN ../src.orig/backend/executor/execMain.c ./backend/executor/execMain.c
*** ../src.orig/backend/executor/execMain.c	Sat Jun  2 11:17:48 2001
--- ./backend/executor/execMain.c	Sat Jun  2 11:18:33 2001
***************
*** 1671,1677 ****
  	{
  		Buffer		buffer;
  
! 		heap_fetch(relation, SnapshotDirty, &tuple, &buffer);
  		if (tuple.t_data != NULL)
  		{
  			TransactionId xwait = SnapshotDirty->xmax;
--- 1671,1677 ----
  	{
  		Buffer		buffer;
  
! 		heap_fetch(relation, SnapshotDirty, &tuple, &buffer, NULL);
  		if (tuple.t_data != NULL)
  		{
  			TransactionId xwait = SnapshotDirty->xmax;
diff -crN ../src.orig/backend/executor/nodeIndexscan.c ./backend/executor/nodeIndexscan.c
*** ../src.orig/backend/executor/nodeIndexscan.c	Sat Jun  2 11:17:48 2001
--- ./backend/executor/nodeIndexscan.c	Sat Jun  2 11:18:33 2001
***************
*** 173,179 ****
  		while ((result = index_getnext(scandesc, direction)) != NULL)
  		{
  			tuple->t_self = result->heap_iptr;
! 			heap_fetch(heapRelation, snapshot, tuple, &buffer);
  			pfree(result);
  
  			if (tuple->t_data != NULL)
--- 173,179 ----
  		while ((result = index_getnext(scandesc, direction)) != NULL)
  		{
  			tuple->t_self = result->heap_iptr;
! 			heap_fetch(heapRelation, snapshot, tuple, &buffer, scandesc);
  			pfree(result);
  
  			if (tuple->t_data != NULL)
diff -crN ../src.orig/backend/executor/nodeTidscan.c ./backend/executor/nodeTidscan.c
*** ../src.orig/backend/executor/nodeTidscan.c	Sat Jun  2 11:17:48 2001
--- ./backend/executor/nodeTidscan.c	Sat Jun  2 11:18:33 2001
***************
*** 152,158 ****
  		if (itemptr)
  		{
  			tuple->t_self = *(itemptr);
! 			heap_fetch(heapRelation, snapshot, tuple, &buffer);
  		}
  		if (tuple->t_data != NULL)
  		{
--- 152,158 ----
  		if (itemptr)
  		{
  			tuple->t_self = *(itemptr);
! 			heap_fetch(heapRelation, snapshot, tuple, &buffer, NULL);
  		}
  		if (tuple->t_data != NULL)
  		{
diff -crN ../src.orig/backend/parser/parse_func.c ./backend/parser/parse_func.c
*** ../src.orig/backend/parser/parse_func.c	Sat Jun  2 11:17:48 2001
--- ./backend/parser/parse_func.c	Sat Jun  2 11:18:33 2001
***************
*** 752,758 ****
  			tuple.t_datamcxt = NULL;
  			tuple.t_data = NULL;
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(heapRelation, SnapshotNow, &tuple, &buffer);
  			pfree(indexRes);
  			if (tuple.t_data != NULL)
  			{
--- 752,758 ----
  			tuple.t_datamcxt = NULL;
  			tuple.t_data = NULL;
  			tuple.t_self = indexRes->heap_iptr;
! 			heap_fetch(heapRelation, SnapshotNow, &tuple, &buffer, sd);
  			pfree(indexRes);
  			if (tuple.t_data != NULL)
  			{
diff -crN ../src.orig/backend/postmaster/Makefile ./backend/postmaster/Makefile
*** ../src.orig/backend/postmaster/Makefile	Sat Jun  2 11:17:49 2001
--- ./backend/postmaster/Makefile	Sat Jun  2 11:18:33 2001
***************
*** 12,18 ****
  top_builddir = ../../..
  include $(top_builddir)/src/Makefile.global
  
! OBJS = postmaster.o
  
  all: SUBSYS.o
  
--- 12,18 ----
  top_builddir = ../../..
  include $(top_builddir)/src/Makefile.global
  
! OBJS = postmaster.o pgstat.o
  
  all: SUBSYS.o
  
